var qahm = qahm || {};
qahm.statsParamDefered = new jQuery.Deferred();

/**
 * 日付用変数( Date Object )
 * fixedToday // 00:00:00:000
 * yesterday	// 23:59:59:999
 * 
 * (number) pastDatasetDays // ajaxでデータを持ってくる日数
 * pastDatasetStart
 * 
 * (number) pastRangeDays //カレンダー・グラフ表示する日数
 * pastRangeStart
 * pastRangeEnd
 */
let pastRangeStart, pastRangeEnd;

//for when label-date changed
let updatingChart = false;



/**------------------------------ */
//確認用
let checkFirstSetDate = false;
let checkDefaultRange = false;
let checkChangedRange= false;
let checkQahmParam = false;
let checkDataMade = false;
//let barON = false;
let checkCsvDLStep = false;
/**------------------------------ */



window.addEventListener('DOMContentLoaded', function() {
		//csv download
		let statsDownloadBtn = document.getElementById('csv-download-btn');
		if ( statsDownloadBtn ) {
			statsDownloadBtn.addEventListener( 'click', function() {
				let gosign = window.confirm( qahm.sprintfAry( qahml10n['download_msg1'], moment(pastRangeStart).format('ll'), moment(pastRangeEnd).format('ll') ) + '\n' + qahml10n['download_msg2'] );
				if( gosign ) {
					qahm.statsDownloadTCsv( pastRangeStart, pastRangeEnd );
				}
			});
		}
});




/** -------------------------------------
 * 日付決定＆取得するデータの期間を設定
 *  set period of data to get from QA_DB
 */
//moment.locale('ja');
moment.locale(qahm.wp_lang_set);
let Today = new Date();
//cron前の深夜は2日前にしておく
let minusday = 1;
if (Today.getHours()< 4) {minusday = 2;}

//タイムゾーンをWP設定に合わせる。（ウィンドウズとChromeの　time-zone「ずれ」向け処理。）
let hrgap = (Today.getTimezoneOffset()) / 60;
Today.setHours( Today.getHours() + hrgap + qahm.wp_time_adj );
let fixedToday = Today.setHours( 0, 0, 0, 0 );

//どの期間のデータを取得するか
let yesterday = new Date(fixedToday);
yesterday.setTime( yesterday.getTime() - minusday *1000*60*60*24 );
yesterday.setHours( 23, 59, 59, 999);
let yesterdayStr = moment(yesterday).format('YYYY-MM-DD');

let pastDatasetDays = 365*2;
let pastDatasetStart = new Date(fixedToday);
pastDatasetStart.setTime( pastDatasetStart.getTime() - pastDatasetDays *1000*60*60*24 );
let pastDatasetStartStr = moment(pastDatasetStart).format('YYYY-MM-DD');

let statsDateForAjax = 'date = between ' + pastDatasetStartStr + ' and ' + yesterdayStr;
//let statsDateForAjax = 'date = between 2021-05-01 and 2021-07-04';

let daysince = new Date(pastDatasetStart);

if( checkFirstSetDate ){
	//console.log('timezone-offset:', hrgap);
	//console.log('today?:', Today);
	//console.log('fixedtoday:', fixedToday);
	console.log('past-start string:', pastDatasetStartStr);
	console.log('yesterday string:', yesterdayStr);
	console.log('ajax date:', statsDateForAjax);
}



/** -------------------------------------
 * データの取得とチャート描画実行
 *  get past data and execute drawing chart
 */
jQuery(
	function(){
		// 見たいデータを探すボタンクリック
		jQuery( '#extraction-view-button' ).on( 'click', function() {
			progradio = document.getElementById('tab_ds');
			progradio.checked = true;
		});

		let deferred = new jQuery.Deferred;
		jQuery.ajax(
			{
				type: 'POST',
				url: qahm.ajax_url,
				dataType : 'json',
				data: {
					'action' : 'qahm_ajax_select_data',
					'table' : 'summary_days_access',
					'select': '*',
					'date_or_id': statsDateForAjax,
					'count' : false,
					'nonce':qahm.nonce_api
				}
			}
		).done(
			function( data ){
				qahm.statsParam = data;
				qahm.statsParamDefered.resolve();
			}
		).fail(
			function( jqXHR, textStatus, errorThrown ){
				qahm.log_ajax_error( jqXHR, textStatus, errorThrown );
				qahm.statsParamDefered.reject();
			}
		).always(
			function(){
			}
		);

		// 実際のデータ取得呼び出し
		qahm.statsParamDefered.promise().then( function() {
			if ( checkQahmParam ) {
				console.log( qahm.statsParam );
			}

			//in data?
			let stattab   = document.getElementById('tab_stats');
			let dstab     = document.getElementById('tab_ds');
			let tablabels = document.getElementsByClassName('tab_item');

			if ( qahm.statsParam === false ) {
				stattab.disabled = true;
				dstab.disabled = true;
				for (let iii = 0; iii < tablabels.length; iii++) {
					if ( tablabels[iii].htmlFor === 'tab_stats' || tablabels[iii].htmlFor === 'tab_ds') {
						tablabels[iii].style.visibility = 'hidden';
					}
				}
			}else{
				stattab.disabled = false;
				dstab.disabled = false;
				for (let iii = 0; iii < tablabels.length; iii++) {
					if ( tablabels[iii].htmlFor === 'tab_stats' || tablabels[iii].htmlFor === 'tab_ds') {
						tablabels[iii].style.visibility = 'visible';
					}
				}
			}
			qahm.statsOrganizeChartData(qahm.statsParam);
			qahm.statsDrawChartOne(labelDates, chartDataArray);
			qahm.statsAggrPeriodTotal();
			qahm.statsFillTotal(periodTotalCount);
		} );
	}
);




/** ------------------------------
 * グラフの期間＆カレンダー設定
 *  set chart-period
 */
//DEFAULT
//let pastRangeDays = 90;
let pastRangeDays;
{
	let threeMonthAgo = new Date();
	threeMonthAgo.setMonth(threeMonthAgo.getMonth() - 3 );
	let tempToday = new Date();
	let nissuu = ( tempToday - threeMonthAgo )/ (1000*60*60*24);
	pastRangeDays = Math.floor(nissuu);
}
let calcDate = new Date(fixedToday);
//let calcDate = new Date( moment('2021-05-01', 'YYYY-MM-DD') );
calcDate.setDate( calcDate.getDate() - pastRangeDays - 1 );

//期間の開始日と終了日
pastRangeStart = new Date(fixedToday);
pastRangeStart.setDate( pastRangeStart.getDate() - pastRangeDays );
pastRangeEnd = new Date(yesterday);

let pickedDates = [];
let labelDates = [];
for( let ttt = 0; ttt < pastRangeDays; ttt++ ){
	calcDate.setDate( calcDate.getDate() + 1 );
	let strDate = moment(calcDate).format('YYYY-MM-DD');
	pickedDates.push(strDate);
	labelDates.push( strDate.substr(5,10) );
}
	if ( checkDefaultRange ) {
		console.log('デフォルトpickedDates', pickedDates);
		console.log('デフォルトlabelDates', labelDates);
	}


//"Date Range Picker"
jQuery(function(){

	//let start = moment(fixedToday).subtract(30, 'days');
	//let end = moment(fixedToday).subtract(1, 'days');
	let statsStart = moment(pastRangeStart);
	let statsEnd	 = moment(pastRangeEnd);

	function cb(statsStart, statsEnd) {
		jQuery('.chart-reportrange span').html(statsStart.format('ll') + ' ' + qahml10n['calender_kara'] + ' ' + statsEnd.format('ll'));
	}

	jQuery('.chart-reportrange').daterangepicker({
			startDate: statsStart,
			endDate: statsEnd,
			showCustomRangeLabel: true, //選択肢にカレンダーありか、なしか。
			//alwaysShowCalendars: true, //選択肢と一緒にカレンダーを開いて表示するか
			linkedCalendars: false, //２つのカレンダーを連動（常に2か月表示）させるか
			ranges: {
				 [qahml10n['calender_kinou']]: [moment(fixedToday).subtract(1, 'days'), moment(fixedToday).subtract(1, 'days')],
				 [qahml10n['calender_kako7days']]: [moment(fixedToday).subtract(7, 'days'), moment(fixedToday).subtract(1, 'days')],
				 [qahml10n['calender_kako30days']]: [moment(fixedToday).subtract(30, 'days'), moment(fixedToday).subtract(1, 'days')],
				 [qahml10n['calender_kongetsu']]: [moment(fixedToday).startOf('month'), moment(fixedToday).endOf('month')],
				 [qahml10n['calender_sengetsu']]: [moment(fixedToday).subtract(1, 'month').startOf('month'), moment(fixedToday).subtract(1, 'month').endOf('month')]
			},
			minDate: moment(pastDatasetStart), // the earliest date which user can choose
			locale: { 
					format: 'll',
					separator: ' ' + qahml10n['calender_kara'] + ' ',
					customRangeLabel: qahml10n['calender_erabu'],
					cancelLabel: qahml10n['calender_cancel'],
					applyLabel: qahml10n['calender_ok'],
				},
	}, cb);


	//期間変更されたら;  when "date range" applied
	jQuery('.chart-reportrange').on('apply.daterangepicker', function(ev, picker) {

		pastRangeStart = new Date(picker.startDate);
		pastRangeEnd = new Date(picker.endDate);

		//change "graph-label-dates"
		pastRangeDays = Math.round( (pastRangeEnd - pastRangeStart) / (1000*60*60*24) ) + 1;

		let calcDate = new Date(pastRangeStart);
		pickedDates.length = 0;
		labelDates.length = 0;
		calcDate.setDate( calcDate.getDate() - 1 );
		for ( let ttt = 0; ttt < pastRangeDays-1; ttt++ ) {
			calcDate.setDate( calcDate.getDate() + 1 );
			let strDate = moment(calcDate).format('YYYY-MM-DD');
			pickedDates.push(strDate);
			labelDates.push( strDate.substr(5,10) );
		}

		if(checkChangedRange){
			console.log('期間変更', pickedDates);
			console.log(labelDates);
		}


		updatingChart = true;		//(already declared at above)
		qahm.statsOrganizeChartData(qahm.statsParam);
		qahm.statsDrawChartOne(labelDates, chartDataArray);
		qahm.statsAggrPeriodTotal();
		qahm.statsFillTotal(periodTotalCount);


	}); // closing func. when 'date-range' applied

	cb(statsStart, statsEnd);
});


/** ---------------------------------
 * organize chart data
 */
let chartDataArray = {};

qahm.statsOrganizeChartData = function(qahmParam) {
	chartDataArray = {
		numPvs:[],
		numSessions:[],
		numUsers:[],
	};

	let indexMarker = 0;

	for ( let ddd = 0; ddd < pickedDates.length; ddd++ ) {
		if ( moment(pickedDates[ddd], 'YYYY-MM-DD') >= fixedToday ) {
			chartDataArray.numPvs.push( null );
			chartDataArray.numSessions.push( null );
			chartDataArray.numUsers.push( null );
		} else {
			let dataExists = false;
			for ( let iii = indexMarker; iii < qahmParam.length; iii++ ) {
				if( qahmParam[iii]['date'] == pickedDates[ddd] ) {
					chartDataArray.numPvs.push( Number(qahmParam[iii]['pv_count']) );
					chartDataArray.numSessions.push( Number(qahmParam[iii]['session_count']) );
					chartDataArray.numUsers.push( Number(qahmParam[iii]['user_count']) );
					indexMarker = iii;
					dataExists = true;
					break;
				}
			}
			if ( ! dataExists ) {
				chartDataArray.numPvs.push( 0 );
				chartDataArray.numSessions.push( 0 );
				chartDataArray.numUsers.push( 0 );
			}
		}
	}
	
	if (checkDataMade){
		console.log('chartDataArray', chartDataArray);
	}
	
};



/** ---------------------------------
 * aggregate total count in the period
 */

let totalOfArray = (accumulator, currentValue) => accumulator + currentValue;

let periodTotalCount = {};
qahm.statsAggrPeriodTotal = function() {
	periodTotalCount = {
		numPvs : 0,
		numSessions : 0,
		numUsers : 0,
	};
	if ( pickedDates.length > 1 ) {
		periodTotalCount = {
			numPvs :			 chartDataArray.numPvs.reduce(totalOfArray),
			numSessions : chartDataArray.numSessions.reduce(totalOfArray),
			numUsers :	 chartDataArray.numUsers.reduce(totalOfArray),
		};
	} else {
		periodTotalCount = {
			numPvs :			 chartDataArray.numPvs[0],
			numSessions : chartDataArray.numSessions[0],
			numUsers :  chartDataArray.numUsers[0],
		};
	}
};



/** ------------------------------
 *  fill "total number" of period aggregation
 */
qahm.statsFillTotal = function( totalAry ){
	let statsBlankAndValues = {
		'qa-num-readers': totalAry.numUsers,
		'qa-num-sessions': totalAry.numSessions,
		'qa-num-pvs': totalAry.numPvs,
	};
	for ( let blankId in statsBlankAndValues ) {
		if ( isNaN(statsBlankAndValues[blankId]) ) {
			statsBlankAndValues[blankId] = '--';
		} 
		let blankToFill = document.getElementById(blankId);
		blankToFill.innerText = statsBlankAndValues[blankId];	
	}
};


/**-------------------------------
 * to clear the chart
 */
 qahm.clearPreChart = function(chartVar) {
	if ( typeof chartVar !== 'undefined' ) {
		chartVar.destroy();
	}
}
qahm.resetCanvas = function(canvasId) {
	let container = document.getElementById(canvasId).parentNode;
	container.innerHTML = '&nbsp;';
	container.innerHTML = `<canvas id="${canvasId}"></canvas>`;
}


/** ---------------------------------------------------
 * drawing graph chart
 */

let statsChart1;

let chartOneColor = {
	users:		{ backgroundColor: "rgba(0, 123, 187, 1)", borderColor: "rgba(0, 123, 187, 1)" },
	sessions: { backgroundColor: "rgba(242, 160, 161)", borderColor: "rgba(242, 160, 161)"},
	pvs:			{ backgroundColor: "rgba(168, 201, 127)", borderColor: "rgba(168, 201, 127)"  },
};

/*
let gOneBkgrdcolor = [
	[ "rgba(0, 123, 187, 1)","rgba(242, 160, 161)","rgba(168, 201, 127)" ],
	[ "rgba(0,123,187,0.2)","rgba(242,160,161,0.2)","rgba(168,201,127,0.2)" ]
]; 
let gOneBdrcolor = [
	[ "rgba(0, 123, 187, 1)","rgba(242, 160, 161)","rgba(168, 201, 127)" ],
	[ "rgba(0,123,187,0.4)","rgba(242,160,161,0.4)","rgba(168,201,127,0.5)" ]
];
*/
let filterSvg = '<svg width="15px" height="15px" version="1.1" id="レイヤー_1" focusable="false" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 320 512" style="enable-background:new 0 0 320 512;" xml:space="preserve"><path fill="#fcc800" d="M20.7,361h85.7c7.7,0,11.6,10.5,6.1,16.7l-42.8,48.4c-3.4,3.8-8.9,3.8-12.2,0l-42.9-48.4C9.1,371.5,13,361,20.7,361z"></path><g><path fill="#fcc800" d="M305.5,86H26.5c-12.8,0-19.3,17.3-10.2,27.4l111.3,123.9v138c0,5.2,2.3,10.2,6.2,13.2l48.1,37.5c9.5,7.4,22.7-0.1,22.7-13.2V237.4l111.3-123.9C324.8,103.3,318.4,86,305.5,86z"></path></g></svg>';
let legendItems;


qahm.statsDrawChartOne = function( labelDateAry, dataAry ) {
	if ( updatingChart ) {
		qahm.clearPreChart(statsChart1);
		qahm.resetCanvas('statsChart1');
	}
	let axisMax;
	let axisStepSize;
	let keepAxis = false;
	let linePointStyle = {};
	if ( labelDateAry.length <= 3 ) {
		linePointStyle = {
			borderWidth: 3,
			radius: 10,
			pointHoverRadius: 15,
		}
	} else if ( labelDateAry.length > 150 ) {
		linePointStyle = {
			borderWidth: 2,
			radius: 0,
			pointHoverRadius: 3,
		}
	} else if ( labelDateAry.length >= 85 ) {
		linePointStyle = {
			borderWidth: 2.5,
			radius: 2,
			pointHoverRadius: 3,
		}
	}else {
		linePointStyle = {
			borderWidth: 3,
			radius: 4,
			pointHoverRadius: 6,
		}
	}

	let ctx = document.getElementById("statsChart1").getContext('2d');
	statsChart1 = new Chart(ctx, {
		type: 'bar',
		data: {
			labels: labelDateAry,
			datasets: [
				{
					type: 'line',
					label: qahml10n['graph_users'],
					data: dataAry.numUsers,
					backgroundColor: chartOneColor.users.backgroundColor,
					borderColor: chartOneColor.users.borderColor,
					borderJoinStyle: 'bevel',
					borderWidth: linePointStyle.borderWidth,
					borderDash: [10, 1, 2, 1],
					pointStyle: 'rectRot',
					radius: linePointStyle.radius,
					pointHoverRadius: linePointStyle.pointHoverRadius,
					lineTension: 0,
					fill: false,
					yAxisID: 'hidden-y-axis',
					order: 3
				},
				{
					type: 'line',
					label: qahml10n['graph_sessions'],
					data: dataAry.numSessions,
					backgroundColor: chartOneColor.sessions.backgroundColor,
					borderColor: chartOneColor.sessions.borderColor,
					borderJoinStyle: 'bevel',
					borderWidth: linePointStyle.borderWidth,
					pointStyle: 'rect',
					radius: linePointStyle.radius,
					pointHoverRadius: linePointStyle.pointHoverRadius,
					lineTension: 0,
					fill: false,
					yAxisID: 'hidden-y-axis',
					order: 4
				},  
				{
					//type: 'bar',
					label: qahml10n['graph_pvs'],
					data: dataAry.numPvs,
					backgroundColor: chartOneColor.pvs.backgroundColor,
					borderColor: chartOneColor.pvs.borderColor,
					borderWidth: 2,
					maxBarThickness: 100,
					yAxisID: 'main-y-axis',
					order: 6
				}
			]
		},
		options: {
			spanGaps: false,
			responsive: true,
			maintainAspectRatio: false,
			title: {
				display: false,
				text: 'graph title',
				padding:3
			},
			scales: {
				yAxes: [{
					id: 'main-y-axis',
					position: 'left',
          type: 'linear',
					ticks: {
						min: 0,
					},
					beforeBuildTicks: function(axis) {
						if ( keepAxis ) {
							axis.max = axisMax;
							axis.stepSize = axisStepSize;
						} else {
							if( axis.max < 10 ) {
								axis.max = 10;
								axis.stepSize = 1;
							}
							axisMax = axis.max;
							axisStepSize = axis.stepSize;
							keepAxis = true;
						}
					},
				}, {
					id: 'hidden-y-axis',
					position: 'right',
          type: 'linear',
					gridLines: {
					display: false
					},
					ticks: {
						min: 0,
						display: false
					},
					beforeBuildTicks: function(axis) {
							axis.max = axisMax;
							axis.stepSize = axisStepSize;
					} 
				}],
				xAxes: [{
					stacked: true,
				}]
			},
			legend: {
				display: false,
				position: 'top',
				labels: {
					usePointStyle: true
				}
			},
			legendCallback: function(chart) {
				let legendHtml = [];
				let labelDeco;
				legendHtml.push('<ul>');
				let dataSet = chart.data.datasets;
				for ( let lll = 0; lll < dataSet.length; lll++ ) {
					let meta = statsChart1.getDatasetMeta(lll);
					if( meta.hidden === true ){
						labelDeco = 'style="text-decoration:line-through;"'
					} else {
						labelDeco = '';
					}
					/*
					if( lll == 3 ) {
						legendHtml.push('</ul><ul>');
					}
					*/
					legendHtml.push('<li>');
					legendHtml.push('<div class="pt-'+dataSet[lll].pointStyle+'" style="background-color:' + dataSet[lll].backgroundColor +'; border-color:'+dataSet[lll].borderColor +'"></div>');
					/*
					if ( lll >= 3 ) {
						legendHtml.push('<span>'+filterSvg+'</span>');
					}
					*/
					legendHtml.push('<span class="legend-label"'+labelDeco +'>'+dataSet[lll].label+'</span>');
					legendHtml.push('</li>');
				}
				legendHtml.push('</ul>');
				return legendHtml.join("");
			},
			tooltips: {
				mode: 'index',
				itemSort: function(a, b, data) {
					return (a.datasetIndex - b.datasetIndex);
				},
				callbacks: {
					label: function(tooltipItem, data) {
							let label;
							//if ( tooltipItem.datasetIndex < 3 ) {
								label = data.datasets[tooltipItem.datasetIndex].label + ': ' + tooltipItem.yLabel;
							//} else {
							//	label = 'filter';
							//	label += data.datasets[tooltipItem.datasetIndex].label + ': ' + tooltipItem.yLabel;;
							//}
							return label;
					}
			}

			},
			/*
			onClick: function(e) {
				let element = statsChart1.getElementAtEvent(e);
				//console.log(element);
				if (! element || element.length === 0) return;
				let meIndex = element[0]._index;
				let meLabelDate = labelDateAry[meIndex];
				console.log('clicked date:', meLabelDate);
			},
			*/
		}
	});
	qahm.legendHere();

}; //end of "statsDrawChartOne" definition


qahm.legendHere = function() {
	document.getElementById('chart1-legend').innerHTML = statsChart1.generateLegend();

	legendItems = document.getElementById('chart1-legend').getElementsByTagName('li');
	for (let i = 0; i < legendItems.length; i++) {
		legendItems[i].addEventListener("click", (e) =>
			updateDataset(e.target.parentNode, i)
		);
	}
	//to switch dataset when the legend clicked
	let updateDataset = (legendLi, index) => {
		let meta = statsChart1.getDatasetMeta(index);
		let labelSpan = legendLi.querySelector('span.legend-label');
		let hiddenData = meta.hidden === true ? true : false;
		if (hiddenData) {
			labelSpan.style.textDecoration = "none";
			meta.hidden = null;
		} else {
			labelSpan.style.textDecoration = "line-through";
			meta.hidden = true;
		}
		statsChart1.update();
	};

};



/** ---------------------------------------------------
 * 過去データCSVダウンロード
 *  to download past data as csv
 */
qahm.statsDownloadTCsv = function(fromDate, toDate) {

	//jsonをtsv/csv文字列に編集する関数
	// let qaHeaderTerms = [ 'pv_id', 'reader_id', 'UAos', 'UAbrowser', 'country', 'page_id', 'url', 'title', 'device_id', 'source_id', 'utm_source', 'source_domain', 'medium_id', 'utm_medium', 'campaign_id', 'utm_campaign', 'session_no', 'access_time', 'pv', 'speed_msec', 'browse_sec', 'is_last', 'is_newuser', 'version_id', 'is_raw_p', 'is_raw_c', 'is_raw_e' ];
	let qaHeaderTerms = [ 'reader_id', 'UAos', 'UAbrowser', 'url', 'title', 'device_id', 'utm_source', 'source_domain', 'utm_medium', 'utm_campaign', 'session_no', 'access_time', 'pv', 'speed_msec', 'browse_sec', 'is_last', 'is_newuser'];
	let jsonToTCsv = function(json, delimiter) {
		let header = qaHeaderTerms.join(delimiter) + "\n";
		let body = json.map(function(d){
			 return qaHeaderTerms.map(function(key) {
				if ( key === 'device_id' ) {
					switch (d[key]) {
						case '1' :
							return 'pc';
						case '2' :
							return 'tab';
						case '3' :
							return 'smp';
						default :
							return '';
					}
				} else {
					if( d[key] ) {
						return d[key];
					} else {
						return '';
					}
				}
			 }).join(delimiter);
		}).join("\n");
		return header + body;
	}
	//UTF8
	let bom = new Uint8Array([0xEF, 0xBB, 0xBF]);


	// データ数によって、ファイル期間を決定
	let dataBetween = [];
	let fromDateStr = moment(fromDate).format('YYYY-MM-DD');
	let toDateStr = moment(toDate).format('YYYY-MM-DD');

	if ( periodTotalCount.numPvs < 300000 ) {
		dataBetween.push( [fromDateStr, toDateStr] );
	} else {
		let gessuu = toDate.getMonth() - fromDate.getMonth();
		if ( gessuu > 0 ) {
			//月ごとに区切る
			for ( let mmm = 0; mmm <= gessuu; mmm++ ) {
				if( mmm === 0 ) {
					dataBetween.push( [fromDateStr, moment(fromDate).endOf('month').format('YYYY-MM-DD')] );
				} else if ( mmm === gessuu ) {
					dataBetween.push( [moment(toDate).startOf('month').format('YYYY-MM-DD'), toDateStr] );
				} else {
					dataBetween.push( [moment(fromDate).add( mmm, 'months').startOf('month').format('YYYY-MM-DD'), moment(fromDate).add( mmm, 'months').endOf('month').format('YYYY-MM-DD')] );
				}
			}
		} else {
			//（一応　エンタープライズになっているはず。）
			dataBetween.push( [fromDateStr, toDateStr] );
			/*
			//半分に区切ってみる？
			let nissuu = toDate.getDate() - fromeDate.getDate();
			let hanbun = Math.floor( nissuu / 2 );
			dataBetween.push( [fromDateStr, moment(fromDate).add(hanbun, 'days').format('YYYY-MM-DD')] );
			dataBetween.push( [moment(fromDate).add(hanbun+1, 'days').format('YYYY-MM-DD'), toDateStr] );
			*/
		}
	}

	if(checkCsvDLStep){
		console.log('dataBetween:', dataBetween);
	}


	//データ取得とファイルダウンロード
	jQuery(
		function(){
			let noDataMsg = '';
			let nnn = 0;

			let getAndDownloadCsvData = function() {
				let deferredDl = new jQuery.Deferred;
				qahm.statsCsvParam = null;

				if ( nnn < dataBetween.length ) {
					jQuery.ajax(
						{
							type: 'POST',
							url: qahm.ajax_url,
							dataType : 'json',
							data: {
								'action' : 'qahm_ajax_select_data',
								'table' : 'view_pv',
								'select': '*',
								'date_or_id':`date = between ${dataBetween[nnn][0]} and ${dataBetween[nnn][1]}`,
								'count' : false,
								'nonce':qahm.nonce_api
							}
						}
					).done(
						function( data ){
							qahm.statsCsvParam = data;

							let csvParam = qahm.statsCsvParam.flat(1);
								if(checkCsvDLStep){
									console.log('csvParam:', csvParam);
								}

							if ( csvParam.length > 0 ) {
								let fileName = 'QA_Data_' + moment(dataBetween[nnn][0], 'YYYY-MM-DD').format('YYYYMMDD') + '-' + moment(dataBetween[nnn][1], 'YYYY-MM-DD').format('YYYYMMDD');
									if(checkCsvDLStep){
										console.log('fileName', fileName );
									}
								let csvData = jsonToTCsv( csvParam, '\t');
//								let csvData = jsonToTCsv( csvParam, ',');
						
								//出力ファイル名
								let exportedFilename = (fileName || 'export') + '.tsv';
//								let exportedFilename = (fileName || 'export') + '.csv';
								//BLOBに変換
								let blob = new Blob([ bom, csvData ], { 'type' : 'text/tsv' });
//								let blob = new Blob([ bom, csvData ], { 'type' : 'text/csv' });
						
								let downloadLink = document.createElement('a');
								downloadLink.download = exportedFilename;
								downloadLink.href = URL.createObjectURL(blob);
								downloadLink.dataset.downloadurl = ['text/plain', downloadLink.download, downloadLink.href].join(':'); //いる？いらない？　HTML要素に追加されたカスタム属性のデータを表す。これらの属性はカスタムデータ属性と呼ばれており、 HTML とその DOM 表現との間で、固有の情報を交換できるようにします。すべてのカスタムデータは、その属性を設定した要素の HTMLElement インターフェイスを通して使用することができます。 HTMLElement.dataset プロパティでカスタムデータにアクセスできます。
								downloadLink.click();
						
								URL.revokeObjectURL(downloadLink.href);
								
							} else {
								noDataMsg += qahm.sprintfAry( qahml10n['download_done_nodata'], dataBetween[nnn][0], dataBetween[nnn][1] );
							}
							
							nnn++;
							getAndDownloadCsvData();		
						}
					).fail(
						function( jqXHR, textStatus, errorThrown ){
							qahm.log_ajax_error( jqXHR, textStatus, errorThrown );
							deferredDl.reject();
						}
					).always(
						function(){
						}
					);

				} else {
					deferredDl.resolve();
				}
				return deferredDl.promise();
			}; //end of 'getAndDownloadCsvData' definition
	

			//実行			
			getAndDownloadCsvData().then(
			function(){
				if ( noDataMsg ) {
					alert(noDataMsg);
				}
			}, function(e){
				alert( qahml10n['download_error1'] + '\n' + qahml10n['download_error2'] );
			}
			);
		}
	)
};

