var qahm = qahm || {};

// エレメントの表示 / 非表示切り替え.
qahm.toggleShowElement = function( click_elem, tar_elem ) {
	let type = jQuery( click_elem ).attr( 'type' );

	let iframe = jQuery( '#heatmap' );

	// iframe内のコンテンツのdocumentオブジェクト
	let ifrmDoc = iframe[0].contentWindow.document;

	if ( type === 'checkbox' ) {
		jQuery( click_elem ).on(
			'click',
			function() {

				// 強制スクロールテスト
				//jQuery( 'body,html', jQuery( '#heatmap' ).contents() ).animate( {scrollTop: 1000 }, 800, 'swing' );

				// var myIframe = document.getElementById('heatmap');
				// myIframe.contentWindow.scrollTo(0,1000);
				if ( jQuery( this ).prop( 'checked' ) ) {
					jQuery( click_elem ).prop( 'checked', true );
					jQuery( tar_elem, ifrmDoc ).removeClass( 'qahm-hide' );
				} else {
					jQuery( click_elem ).prop( 'checked', false );
					jQuery( tar_elem, ifrmDoc ).addClass( 'qahm-hide' );
				}
			}
		);
	}
};

// デバイス選択ボックスの変更処理
qahm.changeDeviceSelectBox = function() {
	jQuery( '#qahm-bar-device > select' ).change(
		function() {
			// window.location.href = jQuery(this).val();
			qahm.createCap( qahm.type, qahm.id, qahm.ver, jQuery( this ).val(), null, null, true );
		}
	);
};

// バージョン選択ボックスのソース取得
qahm.getVersionSelectBoxSource = function() {
	bar_ver_select = '<select>';
	const verMax   = Number( qahm.verMax );
	const verView  = 30;
	let urlSplit   = location.href.split( '/' );
	/*
	・リストに表示するのは３０アイテムまで。
	・現在のリビジョン＋最新リビジョンを表示

	[例]
	バージョン50（一番上）
	バージョン100
	バージョン99
	バージョン98
	…
	バージョン70
	 */
	bar_ver_select += qahm.getVersionSelectBoxOptionSource( qahm.ver, '' );
	for ( let i = verMax; i > Math.max( 0,verMax - verView ); i-- ) {
		if ( Number( qahm.ver ) === i ) {
			continue;
		}
		urlSplit[urlSplit.length - 3] = i;
		bar_ver_select               += qahm.getVersionSelectBoxOptionSource( i, urlSplit.join( '/' ) );
	}
	bar_ver_select += '</select>';
	return bar_ver_select;
}

// バージョン選択ボックスのoptionタグを構築
qahm.getVersionSelectBoxOptionSource = function( ver, url ) {
	if ( url ) {
		url = ' value="' + url + '"';
	}
	for ( let i = 0, len = qahm.recRefresh.length; i < len; i++ ) {
		if ( qahm.recRefresh[i]['version'] == ver ) {
			if ( qahm.recRefresh[i]['end_date'] ) {
				return null;
			}
			//let date_obj = new Date( qahm.recRefresh[i]['refresh_date'] );
			let date     = qahm.recRefresh[i]['refresh_date'];//date_obj.getFullYear() + '/' + ('0' + (date_obj.getMonth() + 1)).slice( -2 ) + '/' + ('0' + date_obj.getDate()).slice( -2 );
			return '<option' + url + '>Ver.' + ver + ' ' + date + ' - </option>';
		}
	}
	return null;
};

// バージョン選択ボックスの変更処理
qahm.changeVersionSelectbox = function() {
	jQuery( '#qahm-bar-version-select > select' ).on(
		'change',
		function() {
			// 遷移先バージョン取得
			let ver = jQuery( this ).val();
			if (ver != '') {
				qahm.createCap( qahm.type, qahm.id, ver, qahm.dev, null, null, false );
			}
		}
	);
};

// 計測ボタンのソース取得
qahm.getRecCheckBoxSource = function() {
	bar_rec_checked        = '';
	bar_rec_disabled       = '';
	bar_rec_disabled_style = '';

	if ( qahm.allRecFlag ) {
		bar_rec_checked        = ' checked';
		bar_rec_disabled       = ' disabled="disabled"';
		bar_rec_disabled_style = ' style="opacity: 0.5;"';
	}
	if ( qahm.recFlag ) {
		bar_rec_checked = ' checked';
	}

	return '<div class="qahm-checkbox-slide"' + bar_rec_disabled_style + '>' +
				'<span>ON</span>' +
				'<div>' +
					'<input id="qahm-bar-rec-checkbox-input" type="checkbox"' + bar_rec_checked + bar_rec_disabled + '>' +
					'<label for="qahm-bar-rec-checkbox-input"></label>' +
				'</div>' +
				'<span>OFF</span>' +
			'</div>';
};

// 計測ボタン（rec_flag）の変更処理
qahm.changeRecCheckBox = function() {
	jQuery( '#qahm-bar-rec-checkbox-input' ).on(
		'change',
		function() {
			if ( qahm.freeRecFlag ) {
				jQuery( this ).removeAttr( 'checked' ).prop( 'checked', false );

				let intro = window.confirm(
					'「QA Heatmapお友達紹介プログラム」をお使いいただくと2ページ以上の計測を行うことができます。\n' +
					'「お友達紹介プログラム」の詳細を見ますか？\n\n' +
					'▼詳しくはこちら\n' +
					'http://quarka.org/friend-campaign/'
				);
				if ( intro ) {
					window.open( 'http://quarka.org/friend-campaign/', 'QA Heatmapお友達紹介プログラム' );
				}
			}

			let rec = 0;
			if ( jQuery( '#qahm-bar-rec-checkbox-input' ).prop( 'checked' ) ) {
				rec = 1;
			}
			jQuery.ajax(
				{
					type: 'POST',
					url: qahm.ajax_url,
					data: {
						'action' : 'qahm_ajax_change_rec_checkbox',
						'type' : qahm.type,
						'id' : qahm.id,
						'rec': rec,
					},
				}
			).done(
				function(data){
					qahm.log( 'done : ajax_change_rec_checkbox' );
				}
			).fail(
				function(jqXHR, textStatus, errorThrown){
					qahm.log_ajax_error( jqXHR, textStatus, errorThrown );
				}
			);
		}
	);
};
