var qahm = qahm || {};

// ログイン判定
qahm.loadScreen.promise()
	.then(
		function () {
			let d = new jQuery.Deferred();
			qahm.showLoadIcon();
			jQuery.ajax(
				{
					type: 'POST',
					url: qahm.ajax_url,
					data: {
						'action': 'qahm_ajax_init_heatmap_view',
						'type': qahm.type,
						'id': qahm.id,
						'ver': qahm.ver,
						'dev': qahm.dev,
						'version_id': qahm.version_id,
					},
					dataType: 'json',
				}
			).done(
				function (data) {
					// debugレベルがちゃんと動作しているか確かめる
					qahm.const_debug = data['const_debug'];
					qahm.const_debug_level = data['const_debug_level'];
					qahm.locale = data['locale'];
					qahm.dataNum = data['data_num'];
					qahm.verMax = data['ver_max'];
					qahm.recFlag = data['rec_flag'];
					qahm.allRecFlag = data['is_raw_save_all'];
					qahm.freeRecFlag = data['free_rec_flag'];
					qahm.recRefresh = data['rec_refresh'];
					qahm.mergeC = data['merge_c'];
					qahm.mergeAS = data['merge_as'];
					qahm.iframeDoc = document.getElementById('heatmap').contentWindow.document;

					// 定数 わかりやすいように大文字
					qahm.DATA_HEATMAP_SELECTOR_NAME = data['DATA_HEATMAP_SELECTOR_NAME'];
					qahm.DATA_HEATMAP_SELECTOR_X = data['DATA_HEATMAP_SELECTOR_X'];
					qahm.DATA_HEATMAP_SELECTOR_Y = data['DATA_HEATMAP_SELECTOR_Y'];

					qahm.DATA_ATTENTION_SCROLL_PERCENT = data['DATA_ATTENTION_SCROLL_PERCENT'];
					qahm.DATA_ATTENTION_SCROLL_STAY_TIME = data['DATA_ATTENTION_SCROLL_STAY_TIME'];
					qahm.DATA_ATTENTION_SCROLL_EXIT_USER = data['DATA_ATTENTION_SCROLL_EXIT_USER'];
					d.resolve();
				}
			).fail(
				function (jqXHR, textStatus, errorThrown) {
					qahm.log_ajax_error(jqXHR, textStatus, errorThrown);
					d.reject();
				}
			);
			return d.promise();
		}
	)
	.then(
		function () {
			if (qahm.dataNum > 0) {
				qahm.initHeatmap();
				qahm.createClickHeatMap();
				qahm.createScrollMap();
				qahm.createAttentionMap();
				qahm.createClickCountMap();
				qahm.toggleShowElement('.qahm-bar-read', '#qahm-scroll');
				qahm.toggleShowElement('.qahm-bar-attention', '#qahm-attention');
				qahm.toggleShowElement('.qahm-bar-heatmap', '#qahm-heatmap');
				qahm.toggleShowElement('.qahm-bar-click', '#qahm-click');
				qahm.resizeWindow();
			}
			qahm.hideLoadIcon();
		}
	);
