/*
var qahm = qahm || {};

qahm.createVersionTable = function( page ) {
	let def_table = new jQuery.Deferred();
	let def_pager = new jQuery.Deferred();

	page               = page || 1;
	const item         = 5;
	const offs         = (page - 1) * item;
	const pager_around = 2;

	jQuery.ajax(
		{
			type: 'POST',
			url: qahm.ajax_url,
			data: {
				'action' : 'qahm_ajax_get_recrefresh_table',
				'type' : qahm.type,
				'id' : qahm.id,
				'dev' : qahm.dev,
			},
		}
	).done(
		function(data){
			if ( data ) {
				// テーブル
				let html_table = '<table>' +
					'<tr>' +
						'<th>Ver.</th><th>メモ</th><th>データ数</th><th>公開期間</th>' +
					'</tr>';

				const data_len = Math.min( offs + item, data.length );
				for (i = offs; i < data_len; i++) {
					qahm.log( data[i] );
					let end_date = data[i]['end_date'];
					if ( ! end_date ) {
						let dt   = new Date();
						let y    = dt.getFullYear();
						let m    = ('00' + (dt.getMonth() + 1)).slice( -2 );
						let d    = ('00' + dt.getDate()).slice( -2 );
						end_date = y + '-' + m + '-' + d;
					}

					html_table += '<tr>' +
						'<td>' + data[i]['version'] + '</td>' +
						'<td><input type="text" class="qahm-version-table-memo" data-version="' + data[i]['version'] + '" value="' + data[i]['memo'] + '"></td>' +
						'<td>' + data[i]['data_num'] + '</td>' +
						'<td>[' + data[i]['refresh_date'] + '] - [' + end_date + ']</td>' +
					'</tr>';
				}
				html_table += '</table>';
				html_table  = jQuery( html_table );
				jQuery( '#qahm-version-table' ).html( html_table );
				html_table.ready(
					function() {
						def_table.resolve();
					}
				);

				// ページネーション
				let html_page = '<ul>';
				if ( page > 1 ) {
					html_page += '<li class="qahm-version-pager-link" data-page="' + (page - 1) + '">< 前へ</li>';
				} else {
					html_page += '<li>< 前へ</li>';
				}
				const page_item = Math.ceil( data.length / item );
				const page_min  = Math.max( 1, (page - pager_around) );
				const page_max  = Math.min( page_item, (page + pager_around) );
				for (i = page_min; i <= page_max; i++) {
					let active = 'qahm-version-pager-link';
					if ( page === i ) {
						active = 'qahm-version-pager-active'
					}
					html_page += '<li class="' + active + '" data-page="' + i + '">' + i + '</li>';
				}
				if ( page < page_item ) {
					html_page += '<li class="qahm-version-pager-link" data-page="' + (page + 1) + '">次へ ></li>';
				} else {
					html_page += '<li>次へ ></li>';
				}
				html_page += '</ul>';

				html_page = jQuery( html_page );
				jQuery( '#qahm-version-pager' ).empty();
				jQuery( '#qahm-version-pager' ).append( html_page );
				html_page.ready(
					function() {
						def_pager.resolve();
					}
				);
			}
		}
	).fail(
		function( jqXHR, textStatus, errorThrown ){
			qahm.log_ajax_error( jqXHR, textStatus, errorThrown );
			def_table.reject();
			def_pager.reject();
		}
	);

	// メモ欄に更新処理を仕込む
	def_table.promise()
	.then(
		function() {
			jQuery( '.qahm-version-table-memo' ).blur(
				function(){
					let ver = jQuery( this ).data( 'version' );
					let val = jQuery( this ).val();
					jQuery.ajax(
						{
							type: 'POST',
							url: qahm.ajax_url,
							data: {
								'action' : 'qahm_ajax_set_memo',
								'type': qahm.type,
								'id': qahm.id,
								'ver': ver,
								'val': val,
							},
						}
					).done(
						function(data){
							if ( data ) {
								qahm.log( 'メモ' + ver + 'に「' + val + '」を設定' );
							}
						}
					).fail(
						function( jqXHR, textStatus, errorThrown ){
							qahm.log_ajax_error( jqXHR, textStatus, errorThrown );
						}
					);
				}
			);
		}
	);

	// ページャーにスクリプトを仕込む
	def_pager.promise()
	.then(
		function() {
			jQuery( '.qahm-version-pager-link' ).click(
				function() {
					qahm.createVersionTable( jQuery( this ).data( 'page' ) );
				}
			);
		}
	);
};


qahm.createVersionSave = function() {
	jQuery( '#qahm-version-save > div' ).on(
		'click',
		function() {
			qahm.showLoadIcon();
			let def_addrec = new jQuery.Deferred();
			let def_html   = new jQuery.Deferred();
			let ver        = 0;

			jQuery.ajax(
				{
					type: 'POST',
					url: qahm.ajax_url,
					data: {
						'action' : 'qahm_ajax_add_recrefresh_record',
						'type': qahm.type,
						'id': qahm.id,
					},
				}
			).done(
				function(data){
					ver = data;
					qahm.log( 'Ver.' + ver + 'を追加' );
					def_addrec.resolve();
				}
			);

			def_addrec.done(
				function(){
					let start_time = new Date().getTime();
					jQuery.ajax(
						{
							type: 'POST',
							url: qahm.ajax_url,
							data: {
								'action' : 'qahm_ajax_create_heatmap_html',
								'type': qahm.type,
								'id': qahm.id,
								'ver': ver,
								'dev': qahm.dev,
							},
						}
					).done(
						function(data){
							// 最低読み込み時間経過後に処理実行
							let now_time  = new Date().getTime();
							let load_time = now_time - start_time;
							let min_time  = 1000;
							if ( load_time < min_time ) {
								setTimeout( function(){}, (min_time - load_time) );
							}
							// jQuery('#qahm-bar-version-select').empty();
							def_html.resolve();
						}
					);
				}
			);

			def_html.done(
				function(){
					// 最新バージョンの表示更新
					qahm.verMax = ver;
					jQuery( '#qahm-bar-version-select' ).html( qahm.getVersionSelectBoxSource() );
					qahm.createVersionTable();
					qahm.hideLoadIcon();
					qahm.alert( 'Ver.' + ver + 'を追加しました。' );
				}
			);
		}
	);
};

qahm.dragAndDropWindow = function() {
	// 要素の取得
	var elements = document.getElementsByClassName( 'drag-and-drop' );

	// 要素内のクリックされた位置を取得するグローバル（のような）変数
	var x;
	var y;

	// マウスが要素内で押されたとき、又はタッチされたとき発火
	for (var i = 0; i < elements.length; i++) {
		// qahm.log(elements);
		elements[i].addEventListener( 'mousedown', mouseDown, false );
		elements[i].addEventListener( 'touchstart', mouseDown, false );
	}

	// マウスが押された際の関数
	function mouseDown(e) {
		// クラス名に .drag を追加
		this.classList.add( 'drag' );

		// タッチデイベントとマウスのイベントの差異を吸収
		if (e.type === 'mousedown') {
			var event = e;
		} else {
			var event = e.changedTouches[0];
		}

		// 要素内の相対座標を取得
		x = event.pageX - this.offsetLeft;
		y = event.pageY - this.offsetTop;

		// ムーブイベントにコールバック
		noScroll();
		document.body.addEventListener( 'mousemove', mouseMove, false );
		document.body.addEventListener( 'touchmove', mouseMove, false );

		// マウスボタンが離されたとき、またはカーソルが外れたとき発火
		document.body.addEventListener( 'mouseleave', mouseUp, false );
		document.body.addEventListener( 'touchleave', mouseUp, false );
		var drag = document.getElementsByClassName( 'drag' )[0];
		if ( drag ) {
			drag.addEventListener( 'mouseup', mouseUp, false );
			drag.addEventListener( 'touchend', mouseUp, false );
		}
	}

	// マウスカーソルが動いたときに発火
	function mouseMove(e) {
		// 同様にマウスとタッチの差異を吸収
		if (e.type === 'mousemove') {
			var event = e;
		} else {
			var event = e.changedTouches[0];
		}

		// マウスが動いた場所に要素を動かす
		var drag = document.getElementsByClassName( 'drag' )[0];
		if ( drag ) {
			drag.style.top  = event.pageY - y + "px";
			drag.style.left = event.pageX - x + "px";
		}
	}

	// マウスボタンが上がったら発火
	function mouseUp(e) {
		// ムーブベントハンドラの消去
		returnScroll();
		document.body.removeEventListener( 'mousemove', mouseMove, false );
		document.body.removeEventListener( 'touchmove', mouseMove, false );

		// drag も消す
		let drag = document.getElementsByClassName( 'drag' )[0];
		if ( drag ) {
			drag.removeEventListener( 'mouseup', mouseUp, false );
			drag.removeEventListener( 'touchend', mouseUp, false );
			drag.classList.remove( 'drag' );
		}
	}

	function scrollControl(event) {
		event.preventDefault();
	}

	// スクロール禁止
	function noScroll(){
		document.body.addEventListener( 'mousewheel', scrollControl, {passive: false} );
		document.body.addEventListener( 'touchmove', scrollControl, {passive: false} );
	}

	// スクロール禁止解除
	function returnScroll(){
		document.body.removeEventListener( 'mousewheel', scrollControl, {passive: false} );
		document.body.removeEventListener( 'touchmove', scrollControl, {passive: false} );
	}

};
*/