<?php
/**
 * QA Heatmap 定数の宣言
 *
 * constを優先して使用。defineでのみ対応可能な定数はdefine
 *
 * @package qa_heatmap
 */

// プラグイン冒頭で入力されている値のdefine
define( 'QAHM_PLUGIN_NAME', get_file_data( dirname( __FILE__ ) . '/qahm.php', array( 'name' => 'Plugin Name' ) )['name'] );
define( 'QAHM_PLUGIN_VERSION', get_file_data( dirname( __FILE__ ) . '/qahm.php', array( 'version' => 'Version' ) )['version'] );
define( 'QAHM_TEXT_DOMAIN', get_file_data( dirname( __FILE__ ) . '/qahm.php', array( 'text_domain' => 'Text Domain' ) )['text_domain'] );

// プラグイン用
const QAHM_NAME          = 'qahm';
const QAHM_OPTION_PREFIX = QAHM_NAME . '_';

// rectermを完全削除する時に消す
const QAHM_RECTERM_TABLE    = QAHM_NAME . '_recterm';

const QAHM_DEBUG_LEVEL = array (
	'release' => 0,
	'staging' => 1,
	'debug'   => 2
);

const QAHM_DEVICES = array(
	'desktop' => array(
		'name'         => 'dsk',
		'id'           => 1,
		'display_name' => 'desktop',
	),
	'tablet' => array(
		'name'         => 'tab',
		'id'           => 2,
		'display_name' => 'tablet',
	),
	'smartphone' => array(
		'name'         => 'smp',
		'id'           => 3,
		'display_name' => 'smartphone',
	),
);

// qahm用のwp_option 右は初期値
const QAHM_OPTIONS = array(
	'access_role'                  => 'administrator',
	'achievements'                 => '',
	'is_raw_save_all'              => false,
	'data_save_month'              => 2,
	'data_save_pv'                 => 10000,
	'license_plan'                 => 0,
	'license_key'                  => '',
	'license_id'                   => '',
	'license_message'              => '',
	'license_activate_time'        => 0,
	'heatmap_sort_rec'             => 'all',
	'heatmap_sort_view'            => 10,
	'heatmap_measure_max'          => 1,
	'plugin_version'               => QAHM_PLUGIN_VERSION,
	'is_first_heatmap_setting'     => true,
	'campaign_oneyear_popup'       => false,
);

// ここに今は使わなくなったwp_optionの配列を書いたほうが良さそう

const QAHM_DB_OPTIONS = array(
	'qa_readers_version'           => 1,
	'qa_pages_version'             => 1,
	'qa_utm_media_version'         => 1,
	'qa_utm_sources_version'       => 1,
	'qa_utm_campaigns_version'     => 1,
	'qa_pv_log_version'            => 1,
	'qa_search_log_version'        => 1,
	'qa_page_version_hist_version' => 1,
);

require_once dirname( __FILE__ ) . '/qahm-const-ignore.php';
require_once dirname( __FILE__ ) . '/qahm-const-domain.php';

// メモリーの初期値など各ファイル共通
const QAHM_MEMORY_LIMIT_MIN = 256;