<?php
/**
 * QA Heatmap Analytics メインファイル
 *
 * @package qa_heatmap_analytics
 */

/*
Plugin Name: QA Heatmap Analytics
Plugin URI: https://quarka.org/
Description: QA Heatmap Analytics は、ユーザーの行動分析を手軽に行えるヒートマップツールです。プラグインを有効化するだけで、あなたのサイトに訪れた読者の行動データをリアルタイムに取得し始めます。
Author: QuarkA
Author URI: https://quarka.org/
Version: 2.0.7.3
Text Domain: qa-heatmap-analytics
Requires at least: 4.5
Tested up to: 5.8.1
Requires PHP: 5.6
License: GPLv2 or later
License URI: https://www.gnu.org/licenses/old-licenses/gpl-2.0.html
*/

// β版ユーザーへの対策
if ( get_option( 'qahm_all_rec_flag', 12321 ) !== 12321 ) {
	add_action(
		'admin_notices',
		function () {
			echo '<div id="qahm-error-beta" class="error notice is-dismissible">';
				echo '<p>';
				echo 'QA Heatmap β版が有効化されている状態では、QA Heatmap Analyticsを動作させることはできません。<br>
				β版は2020年12月31日で自動停止し、使用不可となります。以下の作業を順番通り行い、公式版のQA Heatmap Analyticsの有効化をお願い致します。<br>
				<br>
				1. QA Heatmap βとQA Heatmap Analyticsを無効化<br>
				2. QA Heatmap β アンインストール<br>
				3. QA Heatmap Analytics 有効化';
				echo '</p>';
			echo '</div>';
		}
	);
	return;
}


// filesystem_methodが direct or ftpextじゃなければヘルプリンクを表示
require_once ABSPATH . 'wp-admin/includes/file.php';
$access_type = get_filesystem_method();
if( ! ( $access_type === 'direct' || $access_type === 'ftpext' ) ) {
    // 直接書き込み権限がない場合は、ユーザーに通知を表示する
	add_action(
		'admin_notices',
		function () {
			echo '<div id="qahm-error-filesystem" class="error notice is-dismissible">';
				echo '<p>';
				// ファイルの書き込み権限が無いためQA Heatmapを有効化できません。
				_e( 'QA Heatmap cannot be enabled because you do not have write permission for the file. Please refer to following URL(<a href="https://quarka.org/faq/" target="_blank">https://quarka.org/faq/</a>)', 'qa-heatmap-analytics' );
				echo '</p>';
			echo '</div>';
		}
	);
	return;
}

// include
require_once dirname( __FILE__ ) . '/qahm-const.php';
require_once dirname( __FILE__ ) . '/class-qahm-base.php';
require_once dirname( __FILE__ ) . '/class-qahm-time.php';
require_once dirname( __FILE__ ) . '/class-qahm-log.php';
require_once dirname( __FILE__ ) . '/class-qahm-file-base.php';
require_once dirname( __FILE__ ) . '/class-qahm-file-data.php';
require_once dirname( __FILE__ ) . '/class-qahm-db.php';
require_once dirname( __FILE__ ) . '/class-qahm-license.php';
require_once dirname( __FILE__ ) . '/class-qahm-update.php';
require_once dirname( __FILE__ ) . '/class-qahm-behavioral-data.php';
require_once dirname( __FILE__ ) . '/class-qahm-rec-term.php';
require_once dirname( __FILE__ ) . '/class-qahm-article-post.php';
require_once dirname( __FILE__ ) . '/class-qahm-article-list.php';
require_once dirname( __FILE__ ) . '/class-qahm-cron-proc.php';
require_once dirname( __FILE__ ) . '/class-qahm-view-base.php';
require_once dirname( __FILE__ ) . '/class-qahm-view-heatmap.php';
require_once dirname( __FILE__ ) . '/class-qahm-view-replay.php';
require_once dirname( __FILE__ ) . '/class-qahm-view-page-data.php';
require_once dirname( __FILE__ ) . '/class-qahm-data-api.php';
require_once dirname( __FILE__ ) . '/class-qahm-admin-page-base.php';
require_once dirname( __FILE__ ) . '/class-qahm-admin-page-home.php';
require_once dirname( __FILE__ ) . '/class-qahm-admin-page-heatmap.php';
require_once dirname( __FILE__ ) . '/class-qahm-admin-page-config.php';
require_once dirname( __FILE__ ) . '/class-qahm-admin-page-license.php';
require_once dirname( __FILE__ ) . '/class-qahm-admin-page-help.php';
require_once dirname( __FILE__ ) . '/class-qahm-admin-common.php';
require_once dirname( __FILE__ ) . '/class-qahm-activate.php';
require_once dirname( __FILE__ ) . '/class-qahm-load.php';
